/**
 * @file mirror/pre_registered/class/boost/optional.hpp
 * @brief Pre-registration of the boost::optional template class with Mirror
 *
 *  Copyright 2008-2010 Matus Chochlik. Distributed under the Boost
 *  Software License, Version 1.0. (See accompanying file
 *  LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
 */

#ifndef MIRROR_PRE_REGISTERED_CLASS_BOOST_OPTIONAL_1101110333_HPP
#define MIRROR_PRE_REGISTERED_CLASS_BOOST_OPTIONAL_1101110333_HPP

#include <mirror/meta_type_template.hpp>
#include <mirror/pre_registered/namespace/boost.hpp>
#include <boost/optional/optional.hpp>

MIRROR_REG_BEGIN

MIRROR_REG_CLASS_TEMPLATE_BEGIN(
	(typename Type),
	struct, boost, optional, (Type)
)
/* TODO: this should be probably handled as a container element
MIRROR_REG_CLASS_MEM_VARS_BEGIN
	MIRROR_REG_CLASS_MEM_VAR_GET_SET(
		public,
		_,
		Type,
		value,
		_.get(),
		_ = _value,
		!_,
		_ = _this()
	)
MIRROR_REG_CLASS_MEM_VARS_END
 */

MIRROR_REG_CONSTRUCTORS_BEGIN
	MIRROR_REG_CONSTRUCTOR_BEGIN(public, 0)
		MIRROR_REG_CONSTRUCTOR_PARAM(Type, value)
	MIRROR_REG_CONSTRUCTOR_END(0)
	MIRROR_REG_DEFAULT_CONSTRUCTOR(public)
	MIRROR_REG_COPY_CONSTRUCTOR(public)
MIRROR_REG_CONSTRUCTORS_END
MIRROR_REG_CLASS_END

MIRROR_REG_END

#endif //include guard

